# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

package Bugzilla::Extension::DependentProducts::Config;
use strict;
use warnings;
use 5.10.1;

use constant NAME => 'DependentProducts';

use constant REQUIRED_MODULES => [
  {package => 'List-Compare', module => 'List::Compare', version => 0,},
  {package => 'List-UtilsBy', module => 'List::UtilsBy', version => 0,},
];

use constant OPTIONAL_MODULES => [];

__PACKAGE__->NAME;

__END__

=head1 Description

Bugzilla::Extension::DependentProducts

=head1 Dependencies

=head2 Required Modules

=over 4

=item Bugzilla

=item L<List::Compare>

=item L<List::UtilsBy>

=back

=head2 Optional Modules

None.

