/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */
 
 // Escape jquery special chars
function jq(myid) {
    return myid.replace(/(:|\.|\[|\]|,)/g, "\\$1");
}

function hideResolution(statusId, resolutionId, closedList) {
    var sta = document.getElementById(statusId);
    var res = document.getElementById(resolutionId);

    var has_closed = 0;
    for (i = 0; i < sta.length; i++) {
        if (sta.options[i].selected) { // Option is selected
            if (closedList.indexOf(sta.options[i].value) != -1) { // It's closed
                has_closed = 1;
                break;
            }
        }
    }

    if (has_closed)
        res.style.display = '';
    else
        res.style.display = 'none';
}

function rh_show_row() {
    // REDHAT EXTENSION START 1320785
    var $sel = $('#field').selectize()[0].selectize;

    if ($sel.items.length === 0)
        return;

    if ($sel.getValue().substr(0, 7) === 'custom_') {
        // Custom values are processed differently. The row is added via JS,
        // and we don't remove the entry from the drop down
        var f = $sel.getValue().substr(7);
        rh_custom_search_add_row('', f, '', '');
        $sel.clear(1);
    } else {
        var myval = $sel.getValue();
        $('#' + jq(myval) + '_row').show();
        $sel.clear(1);
        $sel.removeOption(myval);
    }
    // REDHAT EXTENSION END 1320785
}

// Clear out the contents of a form row so that submitting it
// will do nothing.
function rh_reset_row(rule_row) {
    var obj = document.getElementById(rule_row);
    if (typeof obj === 'undefined') {
        return false;
    }

    // Clear out any <select> fields
    var select = obj.getElementsByTagName('select');
    for (var i = 0; i < select.length; i++) {
        var select_elem = select[i];
        if (select_elem.name.search('p2_custom_f') == 0) {
            // Don't reset the custom search field drop down
            continue;
        }

        $(select_elem).clearSel();
    }

    // Clear out any <input> fields
    var input = obj.getElementsByTagName('input');
    for (var i = 0; i < input.length; i++) {
        var input_elem = input[i];
        switch (input_elem.type) {
            case 'checkbox':
                input_elem.checked = false;
                break;
            case 'text':
                input_elem.value = '';
                break;
        }
    }

    // Clear out any <textarea> fields
    var text = obj.getElementsByTagName('textarea');
    for (var i = 0; i < text.length; i++) {
        text[i].value = '';
    }

    return false;
}

function rh_custom_search_add_row(n, f, o, v) {
    var tab = document.getElementById('rh_custom_search');
    var rows = tab.rows.length + 1;
    var row = tab.insertRow(rows - 1);

    var row_id = 'rh_custom_search_' + f + '_' + String(rows);
    row.id = row_id;

    var cel = row.insertCell(0);
    var extra = (n == 0) ? '' : ' checked="checked"';
    cel.innerHTML = '<input type="checkbox" name="p2_custom_n' + rows +
        '" id="p2_custom_n' + rows + '"' + extra + '> Not';

    var sel = document.createElement('input');
    sel.name = 'p2_custom_f' + rows;
    var cel = row.insertCell(1);
    var sel = document.createElement('select');
    sel.name = 'p2_custom_f' + rows;
    for (value in field_values) {
        var s = (f == value) ? 1 : 0;
        sel.options[sel.options.length] = new Option(field_values[value], value, s, s);
    }
    cel.appendChild(sel);

    cel = row.insertCell(2);
    sel = document.createElement('select');
    sel.name = 'p2_custom_o' + rows;
    for (value in search_types) {
        var s = (o == value) ? 1 : 0;
        sel.options[sel.options.length] = new Option(search_types[value], value, s, s);
    }
    cel.appendChild(sel);

    cel = row.insertCell(3);
    var inp = document.createElement('input');
    inp.name = 'p2_custom_v' + rows;
    inp.value = v;
    inp.type = 'text'
    cel.appendChild(inp);

    var delbutton = document.createElement('input');
    delbutton.type = 'button';
    delbutton.value = 'Reset';
    delbutton.onclick = function () {
        rh_reset_row(row_id);
    };
    row.appendChild(delbutton);

}

function show_flag_requestee_field(val, nam) {
    var obj = document.getElementById(nam);
    if (val == '?')
        obj.style.display = 'inline';
    else
        obj.style.display = 'none';
}

function update_group() {

    if($('#p1_rule_group').get_selected_item() === "") {
        return;
    }

    $('#p1_classification')._onAjaxSend();
    $('#p1_product')._onAjaxSend();

    new Rpc("RuleGroup", "get", {
            names: $('#p1_rule_group').get_selected_item()
        })
        .fail(function (error) {
            warn(error);
        })
        .complete(function (cb) {
            $('#p1_classification')._onAjaxComplete();
            $('#p1_product')._onAjaxComplete();
        })
        .done(function (res) {
            $('#p1_classification').clearSel();
            $('#p1_classification').clear_unselected();
            var $sel = $('#p1_classification').selectize()[0].selectize;
            $.each(res.rule_groups[0].classifications, function (idx, value) {
                $sel.addOption({value: value, text: value});
            });
            $sel.refreshOptions(false);

            $sel = $('#p1_product').selectize()[0].selectize;
            $('#p1_product').clearSel();
            $('#p1_product').clear_unselected();
            $.each(res.rule_groups[0].products, function (idx, value) {
                $sel.addOption({value: value, text: value});
            });
            $sel.refreshOptions(false);
        });
}